# Class MetalRootPaneUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.RootPaneUI
javax.swing.plaf.basic.BasicRootPaneUI
javax.swing.plaf.metal.MetalRootPaneUI

All Implemented Interfaces:
  `PropertyChangeListener, EventListener`

public class MetalRootPaneUI extends BasicRootPaneUI
Provides the metal look and feel implementation of `RootPaneUI`.

`MetalRootPaneUI` provides support for the `windowDecorationStyle` property of `JRootPane`. `MetalRootPaneUI` does this by way of installing a custom `LayoutManager`, a private `Component` to render the appropriate widgets, and a private `Border`. The `LayoutManager` is always installed, regardless of the value of the `windowDecorationStyle` property, but the `Border` and `Component` are only installed/added if the `windowDecorationStyle` is other than `JRootPane.NONE`.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

Since:
  1.4

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MetalRootPaneUI()`
  Constructs a `MetalRootPaneUI`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ComponentUI`
  `createUI(JComponent c)`
  Creates a UI for a `JRootPane`.
  `void`
  `installUI(JComponent c)`
  Invokes supers implementation of `installUI` to install the necessary state onto the passed in `JRootPane` to render the metal look and feel implementation of `RootPaneUI`.
  `void`
  `propertyChange(PropertyChangeEvent e)`
  Invoked when a property changes.
  `void`
  `uninstallUI(JComponent c)`
  Invokes supers implementation to uninstall any of its state.

  ### Methods declared in class BasicRootPaneUI

  `installComponents, installDefaults, installKeyboardActions, installListeners, uninstallComponents, uninstallDefaults, uninstallKeyboardActions, uninstallListeners`
  Modifier and Type
  Method
  Description
  `protected void`
  `installComponents(JRootPane root)`
  Installs components.
  `protected void`
  `installDefaults(JRootPane c)`
  Installs default properties.
  `protected void`
  `installKeyboardActions(JRootPane root)`
  Registers keyboard actions.
  `protected void`
  `installListeners(JRootPane root)`
  Registers listeners.
  `protected void`
  `uninstallComponents(JRootPane root)`
  Unregisters components.
  `protected void`
  `uninstallDefaults(JRootPane root)`
  Uninstalls default properties.
  `protected void`
  `uninstallKeyboardActions(JRootPane root)`
  Unregisters keyboard actions.
  `protected void`
  `uninstallListeners(JRootPane root)`
  Unregisters listeners.

  ### Methods declared in class ComponentUI

  `contains, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getMaximumSize, getMinimumSize, getPreferredSize, paint, update`
  Modifier and Type
  Method
  Description
  `boolean`
  `contains(JComponent c, int x, int y)`
  Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
  `Accessible`
  `getAccessibleChild(JComponent c, int i)`
  Returns the `i`th `Accessible` child of the object.
  `int`
  `getAccessibleChildrenCount(JComponent c)`
  Returns the number of accessible children in the object.
  `int`
  `getBaseline(JComponent c, int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior(JComponent c)`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `Dimension`
  `getMaximumSize(JComponent c)`
  Returns the specified component's maximum size appropriate for the look and feel.
  `Dimension`
  `getMinimumSize(JComponent c)`
  Returns the specified component's minimum size appropriate for the look and feel.
  `Dimension`
  `getPreferredSize(JComponent c)`
  Returns the specified component's preferred size appropriate for the look and feel.
  `void`
  `paint(Graphics g, JComponent c)`
  Paints the specified component appropriately for the look and feel.
  `void`
  `update(Graphics g, JComponent c)`
  Notifies this UI delegate that it is time to paint the specified component.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### MetalRootPaneUI

    public MetalRootPaneUI()
    Constructs a `MetalRootPaneUI`.

- ## Method Details

  - ### createUI

    public static ComponentUI createUI(JComponent c)
    Creates a UI for a `JRootPane`.
    Parameters:
      `c` - the JRootPane the RootPaneUI will be created for
    Returns:
      the RootPaneUI implementation for the passed in JRootPane

  - ### installUI

    public void installUI(JComponent c)
    Invokes supers implementation of `installUI` to install the necessary state onto the passed in `JRootPane` to render the metal look and feel implementation of `RootPaneUI`. If the `windowDecorationStyle` property of the `JRootPane` is other than `JRootPane.NONE`, this will add a custom `Component` to render the widgets to `JRootPane`, as well as installing a custom `Border` and `LayoutManager` on the `JRootPane`.
    Overrides:
      `installUI` in class `ComponentUI`
    Parameters:
      `c` - the JRootPane to install state onto
    See Also:
      - `ComponentUI.uninstallUI(JComponent)`
      - `JComponent.setUI(ComponentUI)`
      - `JComponent.updateUI()`

  - ### uninstallUI

    public void uninstallUI(JComponent c)
    Invokes supers implementation to uninstall any of its state. This will also reset the `LayoutManager` of the `JRootPane`. If a `Component` has been added to the `JRootPane` to render the window decoration style, this method will remove it. Similarly, this will revert the Border and LayoutManager of the `JRootPane` to what it was before `installUI` was invoked.
    Overrides:
      `uninstallUI` in class `ComponentUI`
    Parameters:
      `c` - the JRootPane to uninstall state from
    See Also:
      - `ComponentUI.installUI(JComponent)`
      - `JComponent.updateUI()`

  - ### propertyChange

    public void propertyChange(PropertyChangeEvent e)
    Invoked when a property changes. `MetalRootPaneUI` is primarily interested in events originating from the `JRootPane` it has been installed on identifying the property `windowDecorationStyle`. If the `windowDecorationStyle` has changed to a value other than `JRootPane.NONE`, this will add a `Component` to the `JRootPane` to render the window decorations, as well as installing a `Border` on the `JRootPane`. On the other hand, if the `windowDecorationStyle` has changed to `JRootPane.NONE`, this will remove the `Component` that has been added to the `JRootPane` as well resetting the Border to what it was before `installUI` was invoked.
    Specified by:
      `propertyChange` in interface `PropertyChangeListener`
    Overrides:
      `propertyChange` in class `BasicRootPaneUI`
    Parameters:
      `e` - A PropertyChangeEvent object describing the event source and the property that has changed.